/*
==--==--==--==--==--==--==--==--==--==--==--==--==--==--==--==--

Namaste

Copyright (C) 2019, 2021-2023  Anonymous

There are several releases over multiple years,
they are listed as ranges, such as: "2021-2023".

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU Lesser General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public License
along with this program.  If not, see <https://www.gnu.org/licenses/>.

::--::--::--::--::--::--::--::--::--::--::--::--::--::--::--::--
*/

//! # Namaste on Windows

#![cfg(windows)]

use {
    core::ptr,
    std::io::{self, Error, ErrorKind, Write},
    crate::Result,
    windows::{
        Win32::{
            Foundation::{self, HANDLE},
            System::Threading,
        },
        core::PCSTR,
    },
};

const HEX_STRS: &[&str] = &[
    "00", "01", "02", "03", "04", "05", "06", "07", "08", "09", "0a", "0b", "0c", "0d", "0e", "0f", "10", "11", "12", "13", "14", "15", "16",
    "17", "18", "19", "1a", "1b", "1c", "1d", "1e", "1f", "20", "21", "22", "23", "24", "25", "26", "27", "28", "29", "2a", "2b", "2c", "2d",
    "2e", "2f", "30", "31", "32", "33", "34", "35", "36", "37", "38", "39", "3a", "3b", "3c", "3d", "3e", "3f", "40", "41", "42", "43", "44",
    "45", "46", "47", "48", "49", "4a", "4b", "4c", "4d", "4e", "4f", "50", "51", "52", "53", "54", "55", "56", "57", "58", "59", "5a", "5b",
    "5c", "5d", "5e", "5f", "60", "61", "62", "63", "64", "65", "66", "67", "68", "69", "6a", "6b", "6c", "6d", "6e", "6f", "70", "71", "72",
    "73", "74", "75", "76", "77", "78", "79", "7a", "7b", "7c", "7d", "7e", "7f", "80", "81", "82", "83", "84", "85", "86", "87", "88", "89",
    "8a", "8b", "8c", "8d", "8e", "8f", "90", "91", "92", "93", "94", "95", "96", "97", "98", "99", "9a", "9b", "9c", "9d", "9e", "9f", "a0",
    "a1", "a2", "a3", "a4", "a5", "a6", "a7", "a8", "a9", "aa", "ab", "ac", "ad", "ae", "af", "b0", "b1", "b2", "b3", "b4", "b5", "b6", "b7",
    "b8", "b9", "ba", "bb", "bc", "bd", "be", "bf", "c0", "c1", "c2", "c3", "c4", "c5", "c6", "c7", "c8", "c9", "ca", "cb", "cc", "cd", "ce",
    "cf", "d0", "d1", "d2", "d3", "d4", "d5", "d6", "d7", "d8", "d9", "da", "db", "dc", "dd", "de", "df", "e0", "e1", "e2", "e3", "e4", "e5",
    "e6", "e7", "e8", "e9", "ea", "eb", "ec", "ed", "ee", "ef", "f0", "f1", "f2", "f3", "f4", "f5", "f6", "f7", "f8", "f9", "fa", "fb", "fc",
    "fd", "fe", "ff",
];

#[test]
fn test_hex_strs() {
    assert!(HEX_STRS.len() > usize::from(u8::max_value()));
    for i in 0..HEX_STRS.len() {
        assert_eq!(format!("{:02x}", i), HEX_STRS[i]);
    }
}

/// # Namaste on Windows
#[derive(Debug)]
pub struct Namaste {

    mutex_handle: HANDLE,

}

impl Namaste {

    /// # Makes new instance using a named mutex object
    pub (crate) fn make<B>(id: B) -> Result<Self> where B: AsRef<[u8]> {
        let id = {
            let id = id.as_ref();

            let mut result = String::with_capacity(id.len().saturating_mul(2).saturating_add(1));
            for b in id {
                result.push_str(HEX_STRS[usize::from(*b)]);
            }
            result.push('\0');
            result
        };

        let mutex_handle = unsafe {
            Threading::CreateMutexA(ptr::null(), true, PCSTR::from_raw(id.as_ptr()))?
        };
        {
            let last_error = unsafe { Foundation::GetLastError() };
            if last_error == Foundation::ERROR_ALREADY_EXISTS {
                if mutex_handle.is_invalid() == false {
                    if unsafe { Foundation::CloseHandle(mutex_handle) == false } {
                        print_err(__!(
                            "CloseHandle() returned `false` for {mutex_handle:?}: {last_error:?}",
                            mutex_handle=mutex_handle, last_error=unsafe { Foundation::GetLastError() },
                        ));
                    }
                }
                return Err(Error::new(ErrorKind::Other, __!("{:?}", last_error)));
            }
        }

        Ok(Self {
            mutex_handle,
        })
    }

}

impl Drop for Namaste {

    fn drop(&mut self) {
        if unsafe { Threading::ReleaseMutex(self.mutex_handle) } == false {
            print_err(__!(
                "ReleaseMutex() returned `false` for {mutex_handle:?}: {last_error:?}",
                mutex_handle=self.mutex_handle, last_error=unsafe { Foundation::GetLastError() },
            ));
        }
        if unsafe { Foundation::CloseHandle(self.mutex_handle) } == false {
            print_err(__!(
                "CloseHandle() returned `false` for {mutex_handle:?}: {last_error:?}",
                mutex_handle=self.mutex_handle, last_error=unsafe { Foundation::GetLastError() },
            ));
        }
    }

}

/// # Prints error
fn print_err<S>(msg: S) where S: AsRef<str> {
    let msg = format!("{}\n", msg.as_ref());
    if io::stderr().lock().write_all(msg.as_bytes()).is_err() {
        eprintln!("{}", msg.trim());
    }
}
